<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>JSViz Force Directed Layout: Modeling XML Data</title>

		<!--	
			Licensed under the Apache License, Version 2.0 (the "License");
			you may not use this file except in compliance with the License.
 			You may obtain a copy of the License at
 
				http://www.apache.org/licenses/LICENSE-2.0

 			Unless required by applicable law or agreed to in writing, software
 			distributed under the License is distributed on an "AS IS" BASIS,
 			WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 			See the License for the specific language governing permissions and
 			limitations under the License.

 			Author: Kyle Scholz      http://kylescholz.com/
 			Copyright: 2006-2007
 		-->
		
		<!-- JSViz Libraries -->
		<script language="JavaScript" src="../physics/ParticleModel.js"></script>
		<script language="JavaScript" src="../physics/Magnet.js"></script>
		<script language="JavaScript" src="../physics/Spring.js"></script>
		<script language="JavaScript" src="../physics/Particle.js"></script>
		<script language="JavaScript" src="../physics/RungeKuttaIntegrator.js"></script>
		
		<script language="JavaScript" src="../layout/graph/ForceDirectedLayout.js"></script>
		<script language="JavaScript" src="../layout/view/GraphView.js"></script>

		<script language="JavaScript" src="../util/Timer.js"></script>
		<script language="JavaScript" src="../util/EventHandler.js"></script>
		<script language="JavaScript" src="../util/Arrow.js"></script>
		<script language="JavaScript" src="../util/MD5.js"></script>

		<script language="JavaScript" src="../io/DataGraph.js"></script>
		<script language="JavaScript" src="../io/HTTP.js"></script>
		<script language="JavaScript" src="../io/XMLTreeLoader.js"></script>

		<script language="JavaScript">
			// Select rendering platform
			var renderNodes = "canvas";
			var renderEdges = "canvas";
			var layout;

			function resize(layout) {
				layout.view.skewBase = layout.container.scrollWidth / 6;
				layout.setSize();
			}

			function init(container) {
				var layout = new ForceDirectedLayout( container,
					{	skew: true,
						useCanvas: true,
						useVector: true,
						edgeRenderer: renderEdges,
						nodeSize: 24,
						dampingIncValue: 1.05,
						springIncValue: 1.05,
						massIncValue: 1.05,
						oriented: true,

						dampingIncrement: function(curValue, migs) {
							var nbMigs = migs ? migs['nbmigs'] : 1;
							var totalMigs = migs ? migs['totalmigs'] : 1;
							var minMigs = migs ? migs['minmigs'] : 1;

							return 1 + (
								Math.log((curValue * nbMigs * this.dampingIncValue) / (totalMigs))
								- Math.log(minMigs / totalMigs)
							)/Math.log(10);
						},
						
						springIncrement: function(curValue, migs) {
							var nbMigs = migs ? migs['nbmigs'] : 1;
							var totalMigs = migs ? migs['totalmigs'] : 1;
							var minMigs = migs ? migs['minmigs'] : 1;

							return 1 + (
								Math.log((curValue * nbMigs * this.springIncValue) / (totalMigs))
								- Math.log(minMigs / totalMigs)
							)/Math.log(10);
						},
						
						massIncrement: function(curValue, migs) {
							var nbMigs = migs ? migs['nbmigs'] : 1;
							var totalMigs = migs ? migs['totalmigs'] : 1;
							var minMigs = migs ? migs['minmigs'] : 1;

							return 1 + (
								Math.log((curValue * nbMigs * this.massIncValue) / (totalMigs))
								- Math.log(minMigs / totalMigs)
							)/Math.log(10);
						},
						
						strokeIncrement: function(curValue, migs) {
							var nbMigs = migs ? migs['nbmigs'] : 1;
							var totalMigs = migs ? migs['totalmigs'] : 1;
							var minMigs = migs ? migs['minmigs'] : 1;

							var result = curValue.match(/(\d+)(\w+)/i);
							var res = (1 + 
								Math.log((parseInt(result[1])*nbMigs) / (totalMigs))
								- Math.log(minMigs / totalMigs)
							) + result[2];
							return res;
						},
					});

				layout.view.skewBase = container.scrollWidth / 6;
				layout.setSize();

				layout.config._default = {
					model: function( dataNode ) {
						return {
							mass: 1,
							color: '#0000B0',
						}
					},
					view: function( dataNode, modelNode ) {
						if(renderNodes=="canvas"  && layout.view.supportCanvas) {
							return( function(particle) {
								this.node_twod.strokeStyle = dataNode.color;
								this.node_twod.fillStyle = dataNode.color;
								this.node_twod.beginPath();
								this.node_twod.arc(
									(particle.positionX*this.skewX) + this.centerX,
									(particle.positionY*this.skewY) + this.centerY,
									this.properties.nodeSize, 0,
									Math.PI*2,true); // Outer circle

								this.node_twod.stroke();
								this.node_twod.fill();

								this.node_twod.font = '1em solid';
								this.node_twod.fillStyle = 'white';
								this.node_twod.textAlign = 'center';
								this.node_twod.textBaseLine = 'bottom';
								this.node_twod.fillText(
									dataNode.label,
									(particle.positionX*this.skewX) + this.centerX,
									(particle.positionY*this.skewY) + this.centerY
								);
							} );
						} else if(renderNodes=="vector" && layout.view.supportVector) {
							var nodeElement = document.createElementNS("http://www.w3.org/2000/svg", "circle");
							nodeElement.setAttribute('stroke', '#888888');
							nodeElement.setAttribute('stroke-width', '.25px');
							nodeElement.setAttribute('fill', dataNode.color);
							nodeElement.setAttribute('r', 6 + 'px');
							nodeElement.onmousedown =  new EventHandler( layout, layout.handleMouseDownEvent, modelNode.id )
							return nodeElement;						
						} else {
							var nodeElement = document.createElement( 'div' );
							nodeElement.style.position = "absolute";
							nodeElement.style.width = "12px";
							nodeElement.style.height = "12px";
							
							var color = dataNode.color.replace( "#", "" );
							nodeElement.style.backgroundImage = "url(http://kylescholz.com/cgi-bin/bubble.pl?title=&r=12&pt=8&b=" + color + "&c=" + color + ")";
							nodeElement.innerHTML = '<img width="1" height="1">';
							nodeElement.onmousedown =  new EventHandler( layout, layout.handleMouseDownEvent, modelNode.id )
							return nodeElement;
						}
					}
				}

        		layout.forces.spring._default = function( nodeA, nodeB, isParentChild ) {
					if (isParentChild) {
						return {
							springConstant: 0.2,
							dampingConstant: 0.2,
							restLength: 32
						}
					} else {
						return {
							springConstant: 0.2,
							dampingConstant: 0.2,
							restLength: 32
						}
					}
				}
				
				layout.forces.spring['A'] = {};
        		layout.forces.spring['A']['B'] = function( nodeA, nodeB, isParentChild ) {
					return {
						springConstant: 0.1,
						dampingConstant: 0.1,
						restLength: 32
					}
				}

        		layout.forces.magnet = function() {
					return {
						magnetConstant: -3000,
						minimumDistance: 32 
					}
				}
				
				// 
				layout.viewEdgeBuilder = function( dataNodeSrc, dataNodeDest ) {
					return {
						'html_pixels': 5,
						'stroke': calcColor( dataNodeSrc, dataNodeDest ),
						'stroke-width': '2px',
						'stroke-dasharray': '2,4',
					}
				}

				function calcColor (src, dest) {
					var newCol = src.label + dest.label;
					var ar = newCol.split("");
					var chrs = [];
					var color = 'black';

					for (var i = 0; i < ar.length; i++) {
						chrs.push(ar[i].charCodeAt(0));
					}

					var md5 = hex_md5(chrs.join("")).split("");
					color = '#' + md5[0] + md5[3] + md5[6] + md5[9] + md5[12] + md5[15];

					return color;
				}

				var buildTimer = new Timer( 0 );
				buildTimer.subscribe( layout );
				buildTimer.start();

				return layout;
			}

			function generateMigrations(Layout) {
				var maxNodes = 10;
				var baseNode = 10;
				var Nodes = new Array();
				var node;

				for (var i = baseNode; i < (baseNode + maxNodes); i++) {
					node = new DataGraphNode();
					node.label = 'N' + i;
					Layout.newDataGraphNode(node);
					Nodes[i] = node;
				}

				Layout.migrations = new Array();

				window.setInterval(function (l, nodes, base, max) {
					var nodeA = baseNode + Math.floor(Math.random()*maxNodes);
					var nodeB = baseNode + Math.floor(Math.random()*maxNodes);

					if (typeof(this.totalmigs) == 'undefined')
						this.totalmigs = 0;

					if (typeof(this.minmigs) == 'undefined')
						this.minmigs = 0;
					
					if (nodeA != nodeB) {
						var nmigs = Math.floor(Math.random()*4);

						if (nmigs <= this.minmigs)
							this.minmigs = minmigs;

						this.totalmigs += nmigs;

						l.migrations[nodes[nodeA].particle.id + "," + nodes[nodeB].particle.id] = {
							nbmigs: nmigs,
							totalmigs: this.totalmigs,
							minmigs: this.minmigs
						};

						l.newDataGraphEdge(nodes[nodeA], nodes[nodeB]);
						l.model.update();
					}
				}, 2000, Layout, Nodes, baseNode, maxNodes)
			}
		</script>
		
		<style type="text/css">
			html, body {
				margin: 0;
				padding: 0;
				font-family: sans-serif;
				width: 100%;
				height: 100%; 
			}

			#graphe {
				height: 100%;
			}
		</style>
	</head>
	<body onload="layout = init( document.getElementById('graphe') ); generateMigrations(layout); " onresize=" resize(layout); " >
		<div id="graphe"></div>
		<div id="debug" style="position:absolute">
		</div>
	</body>
</html>
